package ru.dbotthepony.mc.otm.menu

import it.unimi.dsi.fastutil.ints.IntArrayList
import it.unimi.dsi.fastutil.ints.IntCollection
import net.minecraft.network.RegistryFriendlyByteBuf
import net.minecraft.world.Container
import ru.dbotthepony.mc.otm.container.computeSortedIndices
import ru.dbotthepony.mc.otm.container.sortWithIndices
import ru.dbotthepony.mc.otm.network.MatteryStreamCodec
import ru.dbotthepony.mc.otm.network.StreamCodecs

class SortInput(menu: MatteryMenu, val container: Container, val settings: IItemStackSortingSettings) {
	val input = menu.PlayerInput(MatteryStreamCodec.Collection<RegistryFriendlyByteBuf, Int, IntCollection>(StreamCodecs.VAR_INT, ::IntArrayList)) {
		container.sortWithIndices(it)
	}

	fun clientInput() {
		input.accept(container.computeSortedIndices(settings.actualComparator))
	}
}
